from typing import Optional

from pystac import Item
from registrar.backend.abc import PathBackend, ItemBackend
from registrar.source import Source


class MyPathBackend(PathBackend):
    def __init__(self, exists: False):
        self.exists = exists

    def path_exists(self, source: Optional[Source], path: str) -> bool:
        return self.exists

    def register_path(self, source: Optional[Source], path: str, replace: bool):
        ...

    def deregister_path(self, source: Optional[Source], path: str) -> Optional[str]:
        return path


class MyItemBackend(ItemBackend):
    def __init__(self, exists: False):
        self.exists = exists

    def item_exists(self, source: Optional[Source], item: "Item") -> bool:
        return self.exists

    def register_item(self, source: Optional[Source], item: "Item", replace: bool):
        ...

    def deregister_identifier(self, identifier: str) -> Optional[str]:
        return identifier
